• USACO 2015 Meeting time BFS+最优剪枝


    题目

    题目描述

    Bessie and her sister Elsie want to travel from the barn to their favorite field, such that they leave at exactly the same time from the barn, and also arrive at exactly the same time at their favorite field.

    The farm is a collection of N fields (1 <= N <= 100) numbered 1..N, where field 1 contains the barn and field N is the favorite field. The farm is built on the side of a hill, with field X being higher in elevation than field Y if X < Y. An assortment of M paths connect pairs of fields. However, since each path is rather steep, it can only be followed in a downhill direction. For example, a path

    connecting field 5 with field 8 could be followed in the 5 -> 8 direction but not the other way, since this would be uphill. Each pair of fields is connected by at most one path, so M <= N(N-1)/2.

    It might take Bessie and Elsie different amounts of time to follow a path; for example, Bessie might take 10 units of time, and Elsie 20. Moreover, Bessie and Elsie only consume time when traveling on paths between fields -- since they are in a hurry, they always travel through a field in essentially zero time, never waiting around anywhere.

    Please help determine the shortest amount of time Bessie and Elsie must take in order to reach their favorite field at exactly the same moment.

    Bessie和她的妹妹Elsie想从粮仓去她们最喜欢的田地,也就是能够使她们一起从粮仓离开,并且能同一时间到达的田地。

    这个农场是由N块(1 <= N <= 100)编号为1..N的田地构成的,第一块田地就是粮仓,并且第N块田地是她们最喜欢的田地。这个农场建在山的一边,所以,如果 X < Y 的话则满足第X块田地的高度要高于第Y块田地的高度。在这之中,有M条交错纵横的路径将不同的田地连接起来。不过,显而易见的是,因为每条路都太陡了,所以这些小路只能沿着从高到低的方向走。例如,一条连接第5块田地和第8块田地的小路只能沿着 5 -> 8 的方向走,而不能沿着其他方向,因为那样会成为上坡路。每两块田地最多只能有一条路径相连接,所以一定有 M <= N(N-1)/2。

    有可能的是,Bessie和Elsie两个人走同一条小路会耗费不同的时间;比如,通过同一条小路,Bessie可能会耗费10个单位的时间,而Elsie会耗费20个单位的时间。此外,Bessie和Elsie只会在通过连接两块田地的小路时耗费时间——因为她们太匆忙了,在穿过田地时不会耗费任何时间,也从来不在任何地方停下来等待。

    现在,请你判断出,能够满足使Bessie和Elsie同时出发并且同时到达她们喜欢的田地的最短的时间。

    输入输出格式

    输入格式:

    INPUT: (file meeting.in)

    The first input line contains N and M, separated by a space.

    Each of the following M lines describes a path using four integers A B C D, where A and B (with A < B) are the fields connected by the path, C is the time required for Bessie to follow the path, and D is the time required for Elsie to follow the path. Both C and D are in the range 1..100.

    第一行输入N和M,中间用空格分开。

    接下来的M行,每行有四个整型A B C D,其中,A和B(A < B)代表着两块用这条小路连接的田地,C代表Bessie通过这条小路的时间,而D代表Elsie通过这条小路的时间。C和D均在 1..100 的范围之内。

    输出格式:

    OUTPUT (file meeting.out)

    A single integer, giving the minimum time required for Bessie and

    Elsie to travel to their favorite field and arrive at the same moment.

    If this is impossible, or if there is no way for Bessie or Elsie to reach

    the favorite field at all, output the word IMPOSSIBLE on a single line.

    一个整型,输出的是能够使两人同时出发并且同时到达目的地的最短时间,如果没有满足条件的答案,则输出"IMPOSSIBLE"。

    输入输出样例

    输入样例#1: 
    3 3 
    1 3 1 2 
    1 2 1 2 
    2 3 1 2 
    
    输出样例#1: 
    2 

    说明

    SOLUTION NOTES:

    Bessie is twice as fast as Elsie on each path, but if Bessie takes the

    path 1->2->3 and Elsie takes the path 1->3 they will arrive at the

    same time.

    分析

    拿到这道题我首先想到的是二分,但仔细一想,二分有两个问题:一是这道题的答案不是单调的,二是这道题很难判断情况的可行性。

    然后没有什么特别好的思路,想到的就是“图的遍历”。其实就代表这把所有可能的路径长度都保存下来,最后在终点上找出相同长度的最短就可以了。

    BFS!

    数组bool f[cow][point][cost]表示奶牛cow(0/1)走到point时花费为cost的可行性。

    写完裸的BFS就发现我很愉快的TLE了。把数据下载下来运行,电脑直接卡住了。//-_-

    显然不能裸的BFS暴力搜索啊,完全跑不出答案。如何进行一个完美的剪枝就是问题了。

    声明一个变量MinLen,保存当前已知的可能最短的合题意的长度。当更新了终点上f数组的值的时候,判断是否可以更新MinLen的值。

    若当前搜到的点正在处理的长度已经大于MinLen,那它所带来的答案一定不是最小的,不用将它的后继点继续入队。

    最后我又犯了一个错误。(背景音:我的AC率啊!/瘫倒)剪枝判断(Line 40)到底是&&还是||呢?仔细想一下,其中一个奶牛到这里的时间超了,但是另外一个奶牛还没有超,这个数值仍然可能为之后带来更优的解!

    (然后在我爸的注视下AC了~)

    (从让电脑爆炸的逆天TLE到4ms通过,美滋滋)

    程序

     1 #include <bits/stdc++.h>
     2 using namespace std;
     3 const int MAXN = 100 + 1;
     4 const int MAXM = 5000;
     5 int n, m, Head[MAXN], EdgeCount = 0, MinLen = 100*5000;
     6 bool f[2][MAXN][100*MAXM];
     7 struct node
     8 {
     9     int p, t1, t2;
    10 };
    11 struct edge
    12 {
    13     int Next, Aim, Bessie, Elsie;
    14 }Edge[MAXM];
    15 void insert(int u, int v, int b, int e)
    16 {
    17     Edge[++EdgeCount] = (edge){Head[u], v, b, e};
    18     Head[u] = EdgeCount;
    19 }
    20 void BFS()
    21 {
    22     queue<node> Q;
    23     Q.push((node){1,0,0});
    24     while (!Q.empty())
    25     {
    26         node u = Q.front();
    27         Q.pop();
    28         for (int i = Head[u.p]; i; i = Edge[i].Next)
    29         {
    30             int v = Edge[i].Aim;
    31             f[0][v][u.t1+Edge[i].Bessie] = 1;
    32             f[1][v][u.t2+Edge[i].Elsie] = 1;
    33             if (v == n)
    34             {
    35                 if (f[0][n][u.t1+Edge[i].Bessie] && f[1][n][u.t1+Edge[i].Bessie])
    36                     MinLen = min(MinLen, u.t1+Edge[i].Bessie);
    37                 if (f[1][n][u.t2+Edge[i].Elsie] && f[0][n][u.t2+Edge[i].Elsie])
    38                     MinLen = min(MinLen, u.t2+Edge[i].Elsie);
    39             }
    40             if (u.t1+Edge[i].Bessie<MinLen || u.t2+Edge[i].Elsie<MinLen)
    41                 Q.push((node){v,u.t1+Edge[i].Bessie,u.t2+Edge[i].Elsie});
    42         }
    43     }
    44     for (int i = 1; i <= 100 * 5000; i++)
    45     {
    46         if (f[0][n][i] && f[1][n][i])
    47         {
    48             cout << i << endl;
    49             return;
    50         }
    51     }
    52     cout << "IMPOSSIBLE" << endl;
    53 }
    54 int main()
    55 {
    56     freopen("meet.in","r",stdin);
    57     freopen("meet.out","w",stdout);
    58     cin >> n >> m;
    59     for (int i = 1; i <= m; i++)
    60     {
    61         int u, v, b, e;
    62         cin >> u >> v >> b >> e;
    63         insert(u,v,b,e);
    64     }
    65     BFS();
    66     return 0;
    67 }
  • 相关阅读:
    Oracle数据库中心双活之道:ASM vs VPLEX
    使用Visual C ++和Open Folder自定义环境
    HDU 2563 统计问题(递归,思维题)
    彻底搞定C语言指针(精华版)
    HDU 1000 A + B Problem(指针版)
    图的基本算法(BFS和DFS)
    HDU 1312 Red and Black(DFS,板子题,详解,零基础教你代码实现DFS)
    C语言求最小公倍数和最大公约数三种算法(经典)
    HDU 2504 又见GCD(最大公约数与最小公倍数变形题)
    HDU 2502 月之数(二进制,规律)
  • 原文地址:https://www.cnblogs.com/OIerPrime/p/8419733.html
Copyright © 2020-2023  润新知